## nextpnr 0.9

=== CMakeLists.txt ===
if (CMAKE_BINARY_DIR STREQUAL CMAKE_SOURCE_DIR)
    message(FATAL_ERROR "In-tree builds are not supported. Instead, run:\ncmake . -B build <options> && cmake --build build")
endif()

cmake_minimum_required(VERSION 3.25)
project(nextpnr CXX)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH})

include(CheckCXXCompilerFlag)
include(CheckCXXCompilerHashEmbed)

if (NOT DEFINED CMAKE_SUPPRESS_DEVELOPER_WARNINGS)
    set(CMAKE_SUPPRESS_DEVELOPER_WARNINGS 1 CACHE INTERNAL "No dev warnings")
endif()

# We want to explictly include all include directories when generating the
# compilation database as not all clang/gcc share the same implicit includes
# leading to essentially non-working compile_commands.json
if (CMAKE_EXPORT_COMPILE_COMMANDS)
    set(CMAKE_CXX_STANDARD_INCLUDE_DIRECTORIES
        ${CMAKE_CXX_IMPLICIT_INCLUDE_DIRECTORIES})
endif()

option(BUILD_GUI "Build GUI" OFF)
option(BUILD_PYTHON "Build Python integration" ON)
option(BUILD_RUST "Build Rust integration" OFF)
option(BUILD_TESTS "Build tests" OFF)
option(USE_OPENMP "Use OpenMP to accelerate analytic placer" OFF)
option(STATIC_BUILD "Create static build" OFF)
option(EXTERNAL_CHIPDB "Create build with pre-built chipdb binaries" OFF)
option(WERROR "pass -Werror to compiler (used for CI)" OFF)
option(PROFILER "Link against libprofiler" OFF)
option(USE_IPO "Compile nextpnr with IPO" ON)

set(PROGRAM_PREFIX "" CACHE STRING "Name prefix for executables")

if (BUILD_GUI AND NOT BUILD_PYTHON)
    message(FATAL_ERROR "GUI requires Python to build")
endif()

if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

if (USE_IPO)
    include(CheckIPOSupported)
    check_ipo_supported(RESULT ipo_supported)
    if (ipo_supported)
        message(STATUS "Building with IPO")
        set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
    else()
        message(STATUS "IPO is not supported with this compiler")
        set(CMAKE_INTERPROCEDURAL_OPTIMIZATION FALSE)
    endif()
else()
    message(STATUS "Building without IPO")
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION FALSE)
endif()

check_cxx_compiler_hash_embed(HAS_HASH_EMBED CXX_FLAGS_HASH_EMBED)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX_FLAGS_HASH_EMBED}")
if (EXTERNAL_CHIPDB)
    set(BBASM_MODE "binary")
elseif (HAS_HASH_EMBED)
    set(BBASM_MODE "embed")
elseif (WIN32 AND NOT HAS_HASH_EMBED)
    set(BBASM_MODE "resource")
    add_definitions(-DBBAS_ARE_RESOURCES)
else()
    set(BBASM_MODE "string")
endif()

find_package(Threads)
if (NOT Threads_FOUND)
    add_definitions(-DNPNR_DISABLE_THREADS)
endif()

if (WASI)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lwasi-emulated-mman")
    add_definitions(
        -DBOOST_EXCEPTION_DISABLE
        -DBOOST_NO_EXCEPTIONS
    )
    if (NOT Threads_FOUND)
        add_definitions(-DBOOST_NO_CXX11_HDR_MUTEX)
    endif()
endif()

if (STATIC_BUILD)
    set(Boost_USE_STATIC_LIBS   ON)
    set(Python_USE_STATIC_LIBS  ON)
    if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    elseif (${CMAKE_SYSTEM_NAME} MATCHES "Windows")
        if (MSVC)
            set(CMAKE_CXX_FLAGS_RELEASE "/MT")
            set(CMAKE_CXX_FLAGS_DEBUG "/MTd")
        endif()
    else()
        set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -static")
        if (BUILD_PYTHON)
            find_package(ZLIB)
            find_package(EXPAT)
        endif()
    endif()
endif()

if (EXTERNAL_CHIPDB)
    set(EXTERNAL_CHIPDB_ROOT "${CMAKE_INSTALL_PREFIX}/share/nextpnr" CACHE STRING
        "External chipdb path")
    message(STATUS "Using external chipdb path: ${EXTERNAL_CHIPDB_ROOT}")
    add_definitions("-DEXTERNAL_CHIPDB_ROOT=\"${EXTERNAL_CHIPDB_ROOT}\"")
endif()

# List of families to build
set(FAMILIES generic ice40 ecp5 nexus machxo2 mistral himbaechel)
set(STABLE_FAMILIES generic ice40 ecp5)
set(EXPERIMENTAL_FAMILIES nexus machxo2 mistral himbaechel)

set(ARCH "" CACHE STRING "Architecture family for nextpnr build")
set_property(CACHE ARCH PROPERTY STRINGS ${FAMILIES})

if (NOT ARCH)
    message(STATUS "Architecture needs to be set, set desired one with -DARCH=xxx")
    message(STATUS "Supported architectures are :")
    message(STATUS "  all")
    message(STATUS "  all+alpha")
    foreach (item ${FAMILIES})
        message(STATUS "  ${item}")
    endforeach()
    message(FATAL_ERROR "Architecture setting is mandatory")
endif()

if (ARCH STREQUAL "all+alpha")
    set(ARCH ${STABLE_FAMILIES} ${EXPERIMENTAL_FAMILIES})
elseif (ARCH STREQUAL "all")
    set(ARCH ${STABLE_FAMILIES})
endif()

foreach (item ${ARCH})
    if (NOT item IN_LIST FAMILIES)
        message(FATAL_ERROR "Architecture '${item}' not in list of supported architectures")
    endif()
endforeach()

set(CMAKE_CXX_STANDARD 17)
if (MSVC)
    set(CMAKE_CONFIGURATION_TYPES "Debug;Release" CACHE STRING "" FORCE)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /D_DEBUG /W4 /wd4100 /wd4244 /wd4125 /wd4800 /wd4456 /wd4458 /wd4305 /wd4459 /wd4121 /wd4996")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /W4 /wd4100 /wd4244 /wd4125 /wd4800 /wd4456 /wd4458 /wd4305 /wd4459 /wd4121 /wd4996 /wd4127")
else()
    # N.B. the -Wno-array-bounds is to work around a false positive in GCC 9
    set(WARN_FLAGS "-Wall -Wextra")
    foreach (TRY_WARN_FLAG no-unused-parameter no-missing-field-initializers no-array-bounds no-format-truncation)
        check_cxx_compiler_flag("-W${TRY_WARN_FLAG}" HAS_W${TRY_WARN_FLAG})
        if (HAS_W${TRY_WARN_FLAG})
            set(WARN_FLAGS "${WARN_FLAGS} -W${TRY_WARN_FLAG}")
        endif()
    endforeach()
    if (WERROR)
        set(WARN_FLAGS "${WARN_FLAGS} -Werror")
    endif()
    set(CMAKE_CXX_FLAGS_DEBUG "${WARN_FLAGS} -fPIC -ggdb -pipe")
    if (USE_OPENMP)
        set(CMAKE_CXX_FLAGS_RELEASE "${WARN_FLAGS} -fPIC -O3 -g -pipe -fopenmp")
    else()
        set(CMAKE_CXX_FLAGS_RELEASE "${WARN_FLAGS} -fPIC -O3 -g -pipe")
    endif()
endif()

set(boost_libs filesystem program_options iostreams system)
if (Threads_FOUND)
    list(APPEND boost_libs thread)
endif()
find_package(Boost REQUIRED COMPONENTS ${boost_libs})

if (BUILD_PYTHON)
    # TODO: sensible minimum Python version
    find_package(Python3 3.5 REQUIRED COMPONENTS Interpreter Development.Embed)
    find_package(pybind11 CONFIG)
    if (NOT pybind11_FOUND)
        message(STATUS "Using built-in pybind11")
        add_subdirectory(3rdparty/pybind11 EXCLUDE_FROM_ALL)
    endif()
    include_directories(${Python3_INCLUDE_DIRS})
else()
    find_package(Python3 3.5 REQUIRED COMPONENTS Interpreter)
    add_definitions("-DNO_PYTHON")
endif()

if (BUILD_RUST)
    add_subdirectory(3rdparty/corrosion)
    corrosion_import_crate(MANIFEST_PATH rust/Cargo.toml PROFILE "release" IMPORTED_CRATES RUST_CRATES)
else()
    add_definitions("-DNO_RUST")
endif()

if (BUILD_GUI)
    # Find the Qt5 libraries
    find_package(Qt5 COMPONENTS Core Widgets OpenGL REQUIRED)

    # For higher quality backtraces
    set(CMAKE_ENABLE_EXPORTS ON)

    add_subdirectory(3rdparty/QtPropertyBrowser EXCLUDE_FROM_ALL)
else()
    add_definitions(-DNO_GUI)
endif()

find_package(Eigen3 REQUIRED NO_MODULE)

add_subdirectory(3rdparty/json11)

add_subdirectory(3rdparty/oourafft)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/3rdparty/sanitizers-cmake/cmake" ${CMAKE_MODULE_PATH})
find_package(Sanitizers)

if (BUILD_TESTS)
    add_subdirectory(3rdparty/googletest/googletest EXCLUDE_FROM_ALL)
    enable_testing()
endif()

if (CMAKE_CROSSCOMPILING)
    set(BBA_IMPORT "IMPORTFILE-NOTFOUND" CACHE FILEPATH
        "Path to the `bba-export.cmake` export file from a native build")
    include(${BBA_IMPORT})
else()
    add_subdirectory(bba)
endif()

include(BBAsm)

add_subdirectory(common)
add_subdirectory(common/kernel)
add_subdirectory(common/place)
add_subdirectory(common/route)
add_subdirectory(frontend)
add_subdirectory(json)
add_subdirectory(rust)

if (BUILD_TESTS)
    add_subdirectory(tests/gui)
endif()

add_custom_target(nextpnr-all-bba)

function(add_nextpnr_architecture target)
    cmake_parse_arguments(arg "" "MAIN_SOURCE" "CORE_SOURCES;TEST_SOURCES;CURRENT_SOURCE_DIR;CURRENT_BINARY_DIR" ${ARGN})

    if (NOT arg_CURRENT_SOURCE_DIR)
        set(arg_CURRENT_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
    endif()
    if (NOT arg_CURRENT_BINARY_DIR)
        set(arg_CURRENT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
    endif()

    set(arg_MAIN_SOURCE "${arg_CURRENT_SOURCE_DIR}/${arg_MAIN_SOURCE}")
    list(TRANSFORM arg_CORE_SOURCES PREPEND ${arg_CURRENT_SOURCE_DIR}/)
    list(TRANSFORM arg_TEST_SOURCES PREPEND ${arg_CURRENT_SOURCE_DIR}/)

    # Defs library: used by everything
    #
    # This library doesn't include any code, and is used to share compiler options.

    add_library(nextpnr-${target}-defs INTERFACE)

    target_include_directories(nextpnr-${target}-defs INTERFACE
        ${CMAKE_SOURCE_DIR}/common/kernel
        ${arg_CURRENT_SOURCE_DIR}
    )

    string(TOUPPER ${family} family_upper)
    target_compile_definitions(nextpnr-${target}-defs INTERFACE
        NEXTPNR_NAMESPACE=nextpnr_${family}
        ARCHNAME=${family}
        ARCH_${family_upper}
    )

    # Core library: used by both CLI/GUI and tests

    add_library(nextpnr-${target}-core INTERFACE)

    target_sources(nextpnr-${target}-core INTERFACE
        ${arg_CORE_SOURCES}
    )

    target_link_libraries(nextpnr-${target}-core INTERFACE
        nextpnr-${target}-defs
        nextpnr_kernel
        nextpnr_place
        nextpnr_route
        nextpnr_frontend
        nextpnr_json
    )

    target_link_libraries(nextpnr-${target}-core INTERFACE
        Boost::headers
        ${Boost_LIBRARIES}
        Eigen3::Eigen
        oourafft
    )

    if (Threads_FOUND)
        target_link_libraries(nextpnr-${target}-core INTERFACE Threads::Threads)
    endif()

    if (BUILD_GUI)
        add_subdirectory(${CMAKE_SOURCE_DIR}/gui ${arg_CURRENT_BINARY_DIR}/gui)

        # Upsettingly, there is a cyclic dependency between `common/kernel` and `gui`, so these
        # two libraries have to be added separately to all executable targets.
    endif()

    if (BUILD_PYTHON)
        target_link_libraries(nextpnr-${target}-core INTERFACE ${Python3_LIBRARIES})
        if (STATIC_BUILD)
            target_link_libraries(nextpnr-${target}-core INTERFACE ZLIB::ZLIB EXPAT::EXPAT)
        endif()
    endif()

    if (BUILD_RUST)
        foreach (crate ${RUST_CRATES})
            target_link_libraries(nextpnr-${target}-core INTERFACE ${crate})
        endforeach()
    endif()

    if (PROFILER)
        target_link_libraries(nextpnr-${target}-core INTERFACE profiler)
    endif()

    add_sanitizers(nextpnr-${target}-core)

    # Chip database

    add_library(nextpnr-${target}-bba INTERFACE EXCLUDE_FROM_ALL)

    add_dependencies(nextpnr-all-bba nextpnr-${target}-bba)

    add_library(nextpnr-${target}-chipdb INTERFACE EXCLUDE_FROM_ALL)

    target_link_libraries(nextpnr-${target}-core INTERFACE nextpnr-${target}-chipdb)

    # CLI/GUI runner

    add_executable(nextpnr-${target} ${arg_MAIN_SOURCE})
    set_property(TARGET nextpnr-${target} PROPERTY RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
    set_property(TARGET nextpnr-${target} PROPERTY OUTPUT_NAME ${PROGRAM_PREFIX}nextpnr-${target})
    if (WASI)
        # set(CMAKE_EXECUTABLE_SUFFIX) breaks CMake tests for some reason
        set_property(TARGET nextpnr-${target} PROPERTY SUFFIX ".wasm")
    endif()

    target_link_libraries(nextpnr-${target} PRIVATE nextpnr-${target}-core)
    if (BUILD_GUI)
        target_link_libraries(nextpnr-${target} PRIVATE nextpnr-${target}-gui)
    endif()

    install(TARGETS nextpnr-${target} RUNTIME DESTINATION bin)

    # Test runner

    if (BUILD_TESTS)
        add_test(NAME nextpnr-${target}-test COMMAND nextpnr-${target}-test)

        add_executable(nextpnr-${target}-test ${arg_TEST_SOURCES})
        set_property(TARGET nextpnr-${target}-test PROPERTY RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

=== bba/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25)
project(bba CXX)

set(CMAKE_CXX_STANDARD 17)

find_package(Boost REQUIRED COMPONENTS
    program_options
    system)

add_executable(bbasm
    main.cc)
target_link_libraries(bbasm LINK_PRIVATE
    ${Boost_PROGRAM_OPTIONS_LIBRARY}
    ${Boost_SYSTEM_LIBRARY})
export(TARGETS bbasm FILE ${CMAKE_BINARY_DIR}/bba-export.cmake)

=== common/CMakeLists.txt ===
if (NOT DEFINED CURRENT_GIT_VERSION)
    # Get the latest abbreviated commit hash of the working branch if not already defined outside
    # (e.g. by package manager when building outside of git repository).
    execute_process(
        COMMAND git describe --tags --always
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        OUTPUT_VARIABLE CURRENT_GIT_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/version.h)

add_library(nextpnr_version INTERFACE)

target_include_directories(nextpnr_version INTERFACE ${CMAKE_CURRENT_BINARY_DIR})

target_sources(nextpnr_version INTERFACE
    ${CMAKE_CURRENT_BINARY_DIR}/version.h
)

=== ecp5/CMakeLists.txt ===
if (NOT IMPORT_BBA_FILES)
    include(FindTrellis)
endif()

set(SOURCES
    arch.cc
    archdefs.h
    arch.h
    arch_place.cc
    arch_pybindings.cc
    arch_pybindings.h
    baseconfigs.cc
    bitstream.cc
    bitstream.h
    cells.cc
    cells.h
    config.cc
    config.h
    constids.inc
    dcu_bitstream.h
    gfx.cc
    gfx.h
    globals.cc
    globals.h
    iotypes.inc
    lpf.cc
    pack.cc
    pio.cc
    pio.h
)

add_nextpnr_architecture(${family}
    CORE_SOURCES ${SOURCES}
    MAIN_SOURCE  main.cc
)

set(ALL_ECP5_DEVICES 25k 45k 85k)
set(ECP5_DEVICES ${ALL_ECP5_DEVICES} CACHE STRING
    "Include support for these ECP5 devices (available: ${ALL_ECP5_DEVICES})")
message(STATUS "Enabled ECP5 devices: ${ECP5_DEVICES}")

foreach (device ${ECP5_DEVICES})
    if (NOT device IN_LIST ALL_ECP5_DEVICES)
        message(FATAL_ERROR "Device ${device} is not a supported ECP5 device")
    endif()

    add_bba_produce_command(
        TARGET  nextpnr-${family}-bba
        COMMAND ${Python3_EXECUTABLE}
            ${CMAKE_CURRENT_SOURCE_DIR}/trellis_import.py
            -L ${TRELLIS_LIBDIR}
            -L ${TRELLIS_DATADIR}/util/common
            -L ${TRELLIS_DATADIR}/timing/util
            -p ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
            -g ${CMAKE_CURRENT_SOURCE_DIR}/gfx.h
            ${device}
            > ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${device}.bba.new
        OUTPUT
            ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${device}.bba
        INPUTS
            ${CMAKE_CURRENT_SOURCE_DIR}/trellis_import.py
            ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
            ${CMAKE_CURRENT_SOURCE_DIR}/gfx.h
    )

    add_bba_compile_command(
        TARGET  nextpnr-${family}-chipdb
        OUTPUT  ${family}/chipdb-${device}.bin
        INPUT   ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${device}.bba
        MODE    ${BBASM_MODE}
    )
endforeach()

=== generic/CMakeLists.txt ===
set(SOURCES
    arch.cc
    archdefs.h
    arch.h
    arch_pybindings.cc
    arch_pybindings.h
    cells.cc
    cells.h
    pack.cc
    viaduct_api.cc
    viaduct_api.h
    viaduct_constids.h
    viaduct_helpers.cc
    viaduct_helpers.h
    viaduct/example/constids.inc
    viaduct/example/example.cc
    viaduct/fabulous/constids.inc
    viaduct/fabulous/fab_cfg.h
    viaduct/fabulous/fab_defs.h
    viaduct/fabulous/fabric_parsing.h
    viaduct/fabulous/fabulous.cc
    viaduct/fabulous/fasm.cc
    viaduct/fabulous/fasm.h
    viaduct/fabulous/pack.cc
    viaduct/fabulous/pack.h
    viaduct/fabulous/validity_check.cc
    viaduct/fabulous/validity_check.h
)

add_nextpnr_architecture(${family}
    CORE_SOURCES ${SOURCES}
    MAIN_SOURCE  main.cc
)

target_sources(nextpnr-${family}-chipdb PUBLIC chipdb.cc)

=== gui/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

set(GUI_SOURCES
    application.cc
    application.h
    basewindow.cc
    basewindow.h
    designwidget.cc
    designwidget.h
    fpgaviewwidget.cc
    fpgaviewwidget.h
    line_editor.cc
    line_editor.h
    lineshader.cc
    lineshader.h
    pyconsole.cc
    pyconsole.h
    pythontab.cc
    pythontab.h
    quadtree.h
    treemodel.cc
    treemodel.h
    worker.cc
    worker.h
    ${family}/mainwindow.cc
    ${family}/mainwindow.h
)

qt5_add_resources(GUI_QT_RESOURCES
    base.qrc
    ${family}/nextpnr.qrc
)

add_library(nextpnr-${target}-gui OBJECT
    ${GUI_SOURCES}
    ${GUI_QT_RESOURCES}
)

target_compile_definitions(nextpnr-${target}-gui PUBLIC
    QT_NO_KEYWORDS
)

target_include_directories(nextpnr-${target}-gui PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/${family}
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_include_directories(nextpnr-${target}-gui PRIVATE
    ${CMAKE_SOURCE_DIR}/frontend
    ${CMAKE_SOURCE_DIR}/json
    ${CMAKE_SOURCE_DIR}/3rdparty/QtPropertyBrowser/src
    ${CMAKE_SOURCE_DIR}/3rdparty/imgui
    ${CMAKE_SOURCE_DIR}/3rdparty/qtimgui
)

target_link_libraries(nextpnr-${target}-gui PUBLIC
    Qt5::Widgets
)

target_link_libraries(nextpnr-${target}-gui PRIVATE
    nextpnr-${target}-defs
    nextpnr_version
    Qt5::OpenGL
    QtPropertyBrowser
    pybind11::headers
)

# Currently always the case when the GUI is built.
if (BUILD_PYTHON)
    target_sources(nextpnr-${target}-gui PRIVATE
        ../3rdparty/python-console/ColumnFormatter.cpp
        ../3rdparty/python-console/ParseHelper.cpp
        ../3rdparty/python-console/ParseHelper.BlockParseState.cpp
        ../3rdparty/python-console/ParseHelper.BracketParseState.cpp
        ../3rdparty/python-console/ParseHelper.ContinuationParseState.cpp
        ../3rdparty/python-console/ParseMessage.cpp
        ../3rdparty/python-console/modified/pyredirector.cc
        ../3rdparty/python-console/modified/pyinterpreter.cc
        ../3rdparty/imgui/imgui_widgets.cpp
        ../3rdparty/imgui/imgui_draw.cpp
        ../3rdparty/imgui/imgui.cpp
        ../3rdparty/imgui/imgui_demo.cpp
        ../3rdparty/qtimgui/ImGuiRenderer.cpp
        ../3rdparty/qtimgui/QtImGui.cpp
    )

    target_include_directories(nextpnr-${target}-gui PRIVATE
        ../3rdparty/python-console
        ../3rdparty/python-console/modified
    )
endif()

=== himbaechel/CMakeLists.txt ===
option(HIMBAECHEL_SPLIT "Whether to build one executable per Himbächel microarchitecture" OFF)

set(HIMBAECHEL_SOURCES
    arch.cc
    archdefs.h
    arch.h
    arch_pybindings.cc
    arch_pybindings.h
    chipdb.h
    himbaechel_api.cc
    himbaechel_api.h
    himbaechel_constids.h
    himbaechel_gfxids.h
    himbaechel_helpers.cc
    himbaechel_helpers.h
)

if (HIMBAECHEL_SPLIT)

    function(add_nextpnr_himbaechel_microarchitecture microtarget)
        cmake_parse_arguments(arg "" "" "CORE_SOURCES;TEST_SOURCES" ${ARGN})

        list(TRANSFORM arg_CORE_SOURCES PREPEND ${CMAKE_CURRENT_SOURCE_DIR}/)
        list(TRANSFORM arg_TEST_SOURCES PREPEND ${CMAKE_CURRENT_SOURCE_DIR}/)

        add_nextpnr_architecture(himbaechel-${microtarget}
            CORE_SOURCES ${HIMBAECHEL_SOURCES}
            MAIN_SOURCE  main.cc
            CURRENT_SOURCE_DIR ${CMAKE_SOURCE_DIR}/himbaechel
            CURRENT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}
        )

        target_sources(nextpnr-himbaechel-${microtarget}-core INTERFACE ${arg_CORE_SOURCES})

        if (BUILD_TESTS)
            target_sources(nextpnr-himbaechel-${microtarget}-test PRIVATE ${arg_TEST_SOURCES})
        endif()
    endfunction()

else()

    add_nextpnr_architecture(himbaechel
        CORE_SOURCES ${HIMBAECHEL_SOURCES}
        MAIN_SOURCE  main.cc
    )

    function(add_nextpnr_himbaechel_microarchitecture microtarget)
        cmake_parse_arguments(arg "" "" "CORE_SOURCES;TEST_SOURCES" ${ARGN})

        target_sources(nextpnr-himbaechel-core INTERFACE ${arg_CORE_SOURCES})

        add_library(nextpnr-himbaechel-${microtarget}-bba INTERFACE EXCLUDE_FROM_ALL)

        add_dependencies(nextpnr-himbaechel-bba nextpnr-himbaechel-${microtarget}-bba)

        add_library(nextpnr-himbaechel-${microtarget}-chipdb INTERFACE EXCLUDE_FROM_ALL)

        target_link_libraries(nextpnr-himbaechel-core INTERFACE nextpnr-himbaechel-${microtarget}-chipdb)

        if (BUILD_TESTS)
            target_sources(nextpnr-himbaechel-test PRIVATE ${arg_TEST_SOURCES})
        endif()
    endfunction()

endif()

set(HIMBAECHEL_UARCHES example gowin xilinx ng-ultra gatemate)

set(HIMBAECHEL_UARCH "" CACHE STRING "Microarchitectures for nextpnr-himbaechel build")
set_property(CACHE HIMBAECHEL_UARCH PROPERTY STRINGS ${HIMBAECHEL_UARCHES})

if (NOT HIMBAECHEL_UARCH)
    message(STATUS "Microarchitecture needs to be set, set desired one with -DHIMBAECHEL_UARCH=xxx")
    message(STATUS "Supported Himbächel microarchitectures are :")
    message(STATUS "  all")
    foreach (item ${HIMBAECHEL_UARCHES})
        message(STATUS "  ${item}")
    endforeach()
    message(FATAL_ERROR "Microarchitecture setting is mandatory")
endif()

if (HIMBAECHEL_UARCH STREQUAL "all")
    set(HIMBAECHEL_UARCH ${HIMBAECHEL_UARCHES})
endif()

foreach (uarch ${HIMBAECHEL_UARCH})
    if (NOT uarch IN_LIST HIMBAECHEL_UARCHES)
        message(FATAL_ERROR "Microarchitecture ${uarch} is not a supported Himbächel microarchitecture")
    endif()

    message(STATUS "Configuring Himbächel microarchitecture: ${uarch}")
    add_subdirectory(uarch/${uarch})
endforeach()

=== ice40/CMakeLists.txt ===
if (NOT IMPORT_BBA_FILES)
    include(FindIceStorm)
endif()

set(SOURCES
    arch.cc
    archdefs.h
    arch.h
    arch_place.cc
    arch_pybindings.cc
    arch_pybindings.h
    bitstream.cc
    bitstream.h
    cells.cc
    cells.h
    chains.cc
    chains.h
    constids.inc
    delay.cc
    gfx.cc
    gfx.h
    pack.cc
    pcf.cc
    pcf.h
)

set(TEST_SOURCES
    tests/hx1k.cc
    tests/hx8k.cc
    tests/lp1k.cc
    tests/lp384.cc
    tests/lp8k.cc
    tests/main.cc
    tests/up5k.cc
)

add_nextpnr_architecture(${family}
    CORE_SOURCES ${SOURCES}
    TEST_SOURCES ${TEST_SOURCES}
    MAIN_SOURCE  main.cc
)

set(ALL_ICE40_DEVICES 384 1k 5k u4k 8k)
set(ICE40_DEVICES ${ALL_ICE40_DEVICES} CACHE STRING
    "Include support for these iCE40 devices (available: ${ALL_ICE40_DEVICES})")
message(STATUS "Enabled iCE40 devices: ${ICE40_DEVICES}")

foreach (device ${ICE40_DEVICES})
    if (NOT device IN_LIST ALL_ICE40_DEVICES)
        message(FATAL_ERROR "Device ${device} is not a supported iCE40 device")
    endif()

    if (device STREQUAL "5k")
        set(timing_opts
            --slow ${ICEBOX_DATADIR}/timings_up5k.txt)
    elseif (device STREQUAL "u4k")
        set(timing_opts
            --slow ${ICEBOX_DATADIR}/timings_u4k.txt)
    elseif (device STREQUAL "384")
        set(timing_opts
            --slow ${ICEBOX_DATADIR}/timings_lp384.txt)
    else()
        set(timing_opts
            --fast ${ICEBOX_DATADIR}/timings_hx${device}.txt
            --slow ${ICEBOX_DATADIR}/timings_lp${device}.txt)
    endif()

    add_bba_produce_command(
        TARGET  nextpnr-${family}-bba
        COMMAND ${Python3_EXECUTABLE}
            ${CMAKE_CURRENT_SOURCE_DIR}/chipdb.py
            -p ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
            -g ${CMAKE_CURRENT_SOURCE_DIR}/gfx.h
            ${timing_opts}
            ${ICEBOX_DATADIR}/chipdb-${device}.txt
            > ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${device}.bba.new
        OUTPUT
            ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${device}.bba
        INPUTS
            ${CMAKE_CURRENT_SOURCE_DIR}/chipdb.py
            ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
            ${CMAKE_CURRENT_SOURCE_DIR}/gfx.h
    )

    add_bba_compile_command(
        TARGET  nextpnr-${family}-chipdb
        OUTPUT  ${family}/chipdb-${device}.bin
        INPUT   ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${device}.bba
        MODE    ${BBASM_MODE}
    )
endforeach()

=== json/CMakeLists.txt ===
add_library(nextpnr_json INTERFACE)

target_include_directories(nextpnr_json INTERFACE .)

target_sources(nextpnr_json INTERFACE
    jsonwrite.cc
    jsonwrite.h
)

=== machxo2/CMakeLists.txt ===
if (NOT IMPORT_BBA_FILES)
    include(FindTrellis)
endif()

set(SOURCES
    arch.cc
    archdefs.h
    arch.h
    arch_place.cc
    arch_pybindings.cc
    arch_pybindings.h
    baseconfigs.cc
    bitstream.cc
    bitstream.h
    cells.cc
    cells.h
    config.cc
    config.h
    constids.inc
    gfx.cc
    gfx.h
    globals.cc
    lpf.cc
    pack.cc
)

add_nextpnr_architecture(${family}
    CORE_SOURCES ${SOURCES}
    MAIN_SOURCE  main.cc
)

# Note that the four *X (MachXO) devices fail to import with prjtrellis commit 14ac883fa.
set(ALL_MACHXO2_DEVICES 256X 640X 1200X 2280X 256 640 1200 2000 4000 7000 1300 2100 4300 6900 9400 4300D 9400D)
set(MACHXO2_DEVICES 1200 6900 CACHE STRING
    "Include support for these MachXO2/XO3 devices (available: ${ALL_MACHXO2_DEVICES})")
message(STATUS "Enabled MachXO2/XO3 devices: ${MACHXO2_DEVICES}")

configure_file(machxo2_available.h.in ${CMAKE_CURRENT_BINARY_DIR}/machxo2_available.h)
target_sources(nextpnr-${family}-core PUBLIC ${CMAKE_CURRENT_BINARY_DIR}/machxo2_available.h)
target_include_directories(nextpnr-${family}-core INTERFACE ${CMAKE_CURRENT_BINARY_DIR})
if (BUILD_GUI)
    target_include_directories(nextpnr-${family}-gui PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
endif()

foreach (device ${MACHXO2_DEVICES})
    if (NOT device IN_LIST ALL_MACHXO2_DEVICES)
        message(FATAL_ERROR "Device ${device} is not a supported MachXO2/XO3 device")
    endif()

    add_bba_produce_command(
        TARGET  nextpnr-${family}-bba
        COMMAND ${Python3_EXECUTABLE}
            ${CMAKE_CURRENT_SOURCE_DIR}/facade_import.py
            -L ${TRELLIS_LIBDIR}
            -L ${TRELLIS_DATADIR}/util/common
            -L ${TRELLIS_DATADIR}/timing/util
            -p ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
            -g ${CMAKE_CURRENT_SOURCE_DIR}/gfx.h
            ${device}
            > ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${device}.bba.new
        OUTPUT
            ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${device}.bba
        INPUTS
            ${CMAKE_CURRENT_SOURCE_DIR}/facade_import.py
            ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
            ${CMAKE_CURRENT_SOURCE_DIR}/gfx.h
    )

    add_bba_compile_command(
        TARGET  nextpnr-${family}-chipdb
        OUTPUT  ${family}/chipdb-${device}.bin
        INPUT   ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${device}.bba
        MODE    ${BBASM_MODE}
    )
endforeach()

=== mistral/CMakeLists.txt ===
set(SOURCES
    arch.cc
    archdefs.cc
    archdefs.h
    arch.h
    arch_pybindings.cc
    arch_pybindings.h
    bitstream.cc
    constids.inc
    delay.cc
    globals.cc
    io.cc
    lab.cc
    m10k.cc
    pack.cc
    pins.cc
    qsf.cc
)

add_nextpnr_architecture(${family}
    CORE_SOURCES ${SOURCES}
    MAIN_SOURCE  main.cc
)

set(MISTRAL_ROOT "" CACHE STRING "Mistral install path")
set(MISTRAL_DONT_INSTALL ON)

add_subdirectory(${MISTRAL_ROOT}/tools ${CMAKE_CURRENT_BINARY_DIR}/tools)
add_subdirectory(${MISTRAL_ROOT}/generator ${CMAKE_CURRENT_BINARY_DIR}/generator)
add_subdirectory(${MISTRAL_ROOT}/libmistral ${CMAKE_CURRENT_BINARY_DIR}/libmistral)

find_package(LibLZMA REQUIRED)

target_include_directories(nextpnr-${family}-core INTERFACE
    ${MISTRAL_ROOT}/libmistral
    ${CMAKE_CURRENT_BINARY_DIR}/tools
    ${CMAKE_CURRENT_BINARY_DIR}/libmistral
    ${LIBLZMA_INCLUDE_DIRS}
)

target_link_libraries(nextpnr-${family}-core INTERFACE
    mistral
    ${LIBLZMA_LIBRARIES}
)

=== nexus/CMakeLists.txt ===
if (NOT IMPORT_BBA_FILES)
    include(FindOxide)
endif()

set(SOURCES
    arch.cc
    archdefs.h
    arch.h
    arch_place.cc
    arch_pybindings.cc
    arch_pybindings.h
    bba_version.inc
    constids.inc
    fasm.cc
    global.cc
    io.cc
    pack.cc
    pdc.cc
    pins.cc
    post_place.cc
)

add_nextpnr_architecture(${family}
    CORE_SOURCES ${SOURCES}
    MAIN_SOURCE  main.cc
)

# NOTE: Unlike iCE40 and ECP5; one database can cover all densities of a given family
set(ALL_NEXUS_FAMILIES LIFCL)
set(NEXUS_FAMILIES ${ALL_NEXUS_FAMILIES} CACHE STRING
    "Include support for these Nexus families (available: ${ALL_NEXUS_FAMILIES})")
message(STATUS "Enabled Nexus families: ${NEXUS_FAMILIES}")

foreach (subfamily ${NEXUS_FAMILIES})
    if (NOT subfamily IN_LIST ALL_NEXUS_FAMILIES)
        message(FATAL_ERROR "${subfamily} is not a supported Nexus family")
    endif()

    add_bba_produce_command(
        TARGET  nextpnr-${family}-bba
        COMMAND ${PRJOXIDE_TOOL}
            bba-export ${subfamily}
            ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
            ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${subfamily}.bba.new
        OUTPUT
            ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${subfamily}.bba
        INPUTS
            ${CMAKE_CURRENT_SOURCE_DIR}/bba_version.inc
            ${CMAKE_CURRENT_SOURCE_DIR}/constids.inc
    )

    add_bba_compile_command(
        TARGET  nextpnr-${family}-chipdb
        OUTPUT  ${family}/chipdb-${subfamily}.bin
        INPUT   ${CMAKE_CURRENT_BINARY_DIR}/chipdb-${subfamily}.bba
        MODE    ${BBASM_MODE}
    )
endforeach()

=== debian/changelog ===
nextpnr (0.9-1) unstable; urgency=medium

  * New upstream version 0.9
  * Bump to Standards-Version 4.7.2
  * d/control: Update uploaders {dxld,sjr}@d.o
  * Add NEWS entry for gowin -> himbaechel-gowin change
  * Add patch to use Debian googletest
  * d/control: Add B-D on pybind11-dev

 -- Daniel Gröber <dxld@darkboxed.org>  Sun, 01 Mar 2026 21:11:04 +0100

=== debian/control ===
Source: nextpnr
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Daniel Gröber <dxld@darkboxed.org>, Simon Richter <sjr@debian.org>
Section: electronics
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               qtbase5-dev,
               libboost-filesystem-dev,
               libboost-thread-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-iostreams-dev,
               libqt5opengl5-dev,
               libeigen3-dev,
               googletest,
               pybind11-dev,
               python3-dev,
               fpga-icestorm-chipdb,
               python3-apycula,
               python3-pytrellis,
               help2man
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/electronics-team/nextpnr
Vcs-Git: https://salsa.debian.org/electronics-team/nextpnr.git
Homepage: https://github.com/YosysHQ/nextpnr
Rules-Requires-Root: no
Description: FPGA place and route tool
 nextpnr is a FPGA place and route tool. Its purpose is to turn a
 topological description of digital hardware produced by an FPGA logic
 synthesis tool such as yosys into an elaborate map of connections between
 the hardwired functional units available inside the FPGA's fabric.
 .
 In order to verify the fully implemented design for proper operation at
 high speed timing-analysis of the design is also supported.

Package: nextpnr-ice40
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         nextpnr-ice40-chipdb (= ${binary:Version}),
Suggests: yosys, fpga-icestorm
Conflicts: nextpnr-ice40-qt
Replaces: nextpnr-ice40-qt
Description: ${source:Synopsis} for Lattice iCE40
 ${source:Extended-Description}
 .
 nextpnr-ice40 supports the Lattice iCE40 series of FPGAs and uses the
 hardware description chipdb from the fpga-icestorm package.
 .
 This package supports only the command-line interface, there is also a GUI
 version in the nextpnr-ice40-qt package.

Package: nextpnr-ice40-qt
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         nextpnr-ice40-chipdb (= ${binary:Version}),
Suggests: yosys, fpga-icestorm
Conflicts: nextpnr-ice40
Replaces: nextpnr-ice40
Description: ${source:Synopsis} for Lattice iCE40 - with GUI
 ${source:Extended-Description}
 .
 nextpnr-ice40 supports the Lattice iCE40 series of FPGAs and uses the
 hardware description chipdb from the fpga-icestorm package.
 .
 This package supports both the GUI and command-line interfaces. A slimmer
 command-line only version is available in the nextpnr-ice40 package.

Package: nextpnr-ice40-chipdb
Architecture: any
Depends: ${misc:Depends}
Description: ${source:Synopsis} for Lattice iCE40 -- chipdb files
 ${source:Extended-Description}
 .
 This package contains the chipdb FPGA layout description files.




Package: nextpnr-ecp5
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         nextpnr-ecp5-chipdb (= ${binary:Version})
Suggests: yosys
Conflicts: nextpnr-ecp5-qt
Replaces: nextpnr-ecp5-qt
Description: ${source:Synopsis} for Lattice ECP5
 ${source:Extended-Description}
 .
 nextpnr-ecp5 supports the Lattice ECP5 series of FPGAs.
 .
 This package supports only the command-line interface, there is also a GUI
 version in the nextpnr-ecp5-qt package.

Package: nextpnr-ecp5-qt
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         nextpnr-ecp5-chipdb (= ${binary:Version})
Suggests: yosys
Conflicts: nextpnr-ecp5
Replaces: nextpnr-ecp5
Description: ${source:Synopsis} for Lattice ECP5 - with GUI
 ${source:Extended-Description}
 .
 nextpnr-ecp5 supports the Lattice ECP5 series of FPGAs.
 .
 This package supports both the GUI and command-line interfaces. A slimmer
 command-line only version is available in the nextpnr-ecp5 package.

Package: nextpnr-ecp5-chipdb
Architecture: any
Depends: ${misc:Depends}
Description: ${source:Synopsis} for Lattice ECP5 -- chipdb files
 ${source:Extended-Description}
 .
 This package contains the chipdb FPGA layout description files.




Package: nextpnr-gowin
Depends: nextpnr-himbaechel, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional dummy package -- replaced by nextpnr-himbaechel
 This is a transitional package. It can safely be removed.

Package: nextpnr-gowin-qt
Depends: nextpnr-himbaechel-qt, ${misc:Depends}
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional dummy package -- replaced by nextpnr-himbaechel
 This is a transitional package. It can safely be removed.

Package: nextpnr-gowin-chipdb
Architecture: all
Priority: optional
Section: oldlibs
Description: transitional dummy package -- replaced by nextpnr-himbaechel
 This is a transitional package. It can safely be removed.



Package: nextpnr-himbaechel
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         nextpnr-himbaechel-gowin-chipdb (= ${binary:Version})
Suggests: yosys
Conflicts: nextpnr-himbaechel-qt
Replaces: nextpnr-himbaechel-qt
Description: ${source:Synopsis} for Gowin GW1N
 ${source:Extended-Description}
 .
 nextpnr-himbaechel supports the Gowin GW1N series of FPGAs.
 .
 This package supports only the command-line interface, there is also a GUI
 version in the nextpnr-himbaechel-qt package.

Package: nextpnr-himbaechel-qt
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         nextpnr-himbaechel-gowin-chipdb (= ${binary:Version})
Suggests: yosys
Conflicts: nextpnr-himbaechel
Replaces: nextpnr-himbaechel
Description: ${source:Synopsis} for Gowin GW1N - with GUI
 ${source:Extended-Description}
 .
 nextpnr-himbaechel supports the Gowin GW1N series of FPGAs.
 .
 This package supports both the GUI and command-line interfaces. A slimmer
 command-line only version is available in the nextpnr-himbaechel package.

Package: nextpnr-himbaechel-gowin-chipdb
Architecture: any
Depends: ${misc:Depends}
Description: ${source:Synopsis} for Gowin GW1N -- chipdb files
 ${source:Extended-Description}
 .
 This package contains the chipdb FPGA layout description files.




Package: nextpnr-generic
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: ${source:Synopsis} for Generic FPGAs
 ${source:Extended-Description}
 .
 nextpnr-generic supports nextpnr's synthetic "generic" FPGA.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildopts.mk

CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%d %B %Y")

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

BUILDDIR=$(CURDIR)/debian/build
MAKEFILE := $(firstword $(MAKEFILE_LIST))

COMPONENTS := \
    generic \
    ice40-qt ice40 \
    ecp5-qt ecp5 \
    himbaechel-qt himbaechel \
#

%:
	dh $@

CMAKE_FLAGS_common := \
    -DCURRENT_GIT_VERSION="$(DEB_VERSION)" \
    -DBUILD_PYTHON=ON \
    -DBUILD_TESTS=ON \
    -DEXTERNAL_CHIPDB=ON

CMAKE_FLAGS_generic := \
    $(CMAKE_FLAGS_common) \
    -DARCH=generic

CMAKE_FLAGS_ice40 := \
    $(CMAKE_FLAGS_common) \
    -DARCH=ice40 \
    -DICEBOX_DATADIR=/usr/share/fpga-icestorm/chipdb \
    -DICESTORM_INSTALL_PREFIX=/usr/share/fpga-icestorm/chipdb

CMAKE_FLAGS_ecp5 := \
    $(CMAKE_FLAGS_common) \
    -DTRELLIS_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)/trellis/ \
    -DTRELLIS_DATADIR=/usr/share/trellis/ \
    -DARCH=ecp5

CMAKE_FLAGS_himbaechel := \
    $(CMAKE_FLAGS_common) \
    -DARCH=himbaechel \
    -DHIMBAECHEL_UARCH=gowin \
    -DHIMBAECHEL_SPLIT=ON \
    -DHIMBAECHEL_GOWIN_DEVICES=all

CMAKE_FLAGS_ice40-qt := $(CMAKE_FLAGS_ice40) -DBUILD_GUI=ON
CMAKE_FLAGS_ice40    := $(CMAKE_FLAGS_ice40) -DBUILD_GUI=OFF

CMAKE_FLAGS_ecp5-qt  := $(CMAKE_FLAGS_ecp5) -DBUILD_GUI=ON
CMAKE_FLAGS_ecp5     := $(CMAKE_FLAGS_ecp5) -DBUILD_GUI=OFF

CMAKE_FLAGS_gowin-qt := $(CMAKE_FLAGS_gowin) -DBUILD_GUI=ON
CMAKE_FLAGS_gowin    := $(CMAKE_FLAGS_gowin) -DBUILD_GUI=OFF

CMAKE_FLAGS_himbaechel-qt := $(CMAKE_FLAGS_himbaechel) -DBUILD_GUI=ON
CMAKE_FLAGS_himbaechel    := $(CMAKE_FLAGS_himbaechel) -DBUILD_GUI=OFF

HELP2MAN_FLAGS = \
    --name="Next Generation Place and Route" \
    --version-string="$(DEB_VERSION)" \
    --section=1 \
    --manual="General Commands" \
    --no-info \
    --no-discard-stderr

override_dh_auto_clean:
	rm -rf $(BUILDDIR)
	rm -f debian/nextpnr-*.1
	dh_auto_clean

override_dh_auto_configure override_dh_auto_build override_dh_auto_test override_dh_auto_install:
	+$(MAKE) -f$(MAKEFILE) $(DEB_BUILD_OPTION_PARALLEL:%=-j%) \
                $(patsubst %,$(subst override_dh_auto_,,$@)/%,$(COMPONENTS))

override_dh_installman:
	help2man $(HELP2MAN_FLAGS) debian/nextpnr-generic/usr/bin/nextpnr-generic > debian/nextpnr-generic.1
	help2man $(HELP2MAN_FLAGS) debian/nextpnr-ice40-qt/usr/bin/nextpnr-ice40 > debian/nextpnr-ice40.1
	help2man $(HELP2MAN_FLAGS) debian/nextpnr-ecp5-qt/usr/bin/nextpnr-ecp5 > debian/nextpnr-ecp5.1
	help2man $(HELP2MAN_FLAGS) debian/nextpnr-himbaechel-qt/usr/bin/nextpnr-himbaechel-gowin > debian/nextpnr-himbaechel-gowin.1
	dh_installman

override_dh_installexamples:
	dh_installexamples --exclude=.gitignore

configure/%:
	dh_auto_configure -B$(BUILDDIR)/$* -- $(CMAKE_FLAGS_$*)

# HACK: dh_auto_build strips the MAKEFLAGS jobserver option. Prevent this
# by calling make manually.
build/%:
	cd $(BUILDDIR)/$* && exec $(MAKE) "INSTALL=install --strip-program=true"

test/%:
	dh_auto_test -B$(BUILDDIR)/$*

install/%: ARCH=$(subst -qt,,$*)
install/%:
	dh_auto_install -B$(BUILDDIR)/$* --destdir=$(CURDIR)/debian/nextpnr-$*

execute_before_dh_install:
	for comp in $(filter %-qt,$(COMPONENTS)); do \
	  rm -rv debian/nextpnr-$$comp/usr/share; \
	done

	set -x; \
	for comp in $(filter-out %-qt,$(COMPONENTS)); do \
	  dir=usr/share/nextpnr/$$comp; \
	  if [ -d debian/nextpnr-$$comp/$$dir ]; then \
	    mkdir -p debian/tmp/$$dir && rm -r debian/tmp/$$dir && \
	    mv -viT debian/nextpnr-$$comp/$$dir debian/tmp/$$dir </dev/null; \
	  fi; \
	done

=== debian/tests/control ===
Test-Command: nextpnr-generic --help
Depends: nextpnr-generic
Restrictions: superficial allow-stderr


Test-Command: nextpnr-ice40 --help
Depends: nextpnr-ice40
Restrictions: superficial allow-stderr

Test-Command: nextpnr-ice40 --help
Depends: nextpnr-ice40-qt
Restrictions: superficial allow-stderr


Test-Command: nextpnr-ecp5 --help
Depends: nextpnr-ecp5
Restrictions: superficial allow-stderr

Test-Command: nextpnr-ecp5 --help
Depends: nextpnr-ecp5-qt
Restrictions: superficial allow-stderr


Test-Command: nextpnr-himbaechel-gowin --help
Depends: nextpnr-himbaechel
Restrictions: superficial allow-stderr

Test-Command: nextpnr-himbaechel-gowin --help
Depends: nextpnr-himbaechel-qt
Restrictions: superficial allow-stderr

=== debian/watch ===
# Note: gitmodules needs
#   https://salsa.debian.org/debian/devscripts/-/merge_requests/480
# Should land in uscan/forky

version=4
opts=\
mode=git,\
gitmodules=all,\
compression=gz \
https://github.com/YosysHQ/nextpnr.git refs/tags/nextpnr-@ANY_VERSION@
